//****************************************************************************************************
// file scrivset.cpp
#include <libce.h>

namespace hd {

const ioaddr iBR = 0x01F0;
const ioaddr iCNL = 0x01F4;
const ioaddr iCNH = 0x01F5;
const ioaddr iSNR = 0x01F3;
const ioaddr iHND = 0x01F6;
const ioaddr iSCR = 0x01F2;
const ioaddr iERR = 0x01F1;
const ioaddr iCMD = 0x01F7;
const ioaddr iSTS = 0x01F7;
const ioaddr iDCR = 0x03F6;

};

using namespace hd;

void hd_set_lba(natl lba)
{
	natb lba_0 = lba,
	     lba_1 = lba >> 8,
	     lba_2 = lba >> 16,
	     lba_3 = lba >> 24;

	outputb(lba_0, iSNR);
	outputb(lba_1, iCNL);
	outputb(lba_2, iCNH);
	natb hnd = (lba_3 & 0x0F) | 0xE0;
	outputb(hnd, iHND);
}

void hd_start_cmd(natl lba, natb quanti, natb cmd)
{
	hd_set_lba(lba);
	outputb(quanti, iSCR);					// numero di settori
	outputb(cmd, iCMD);					// comando di scrittura
}

void hd_wait_for_br()
{
	natb s;
	do
		s = inputb(iSTS);
	while (s & 0x88 != 0x08);
}

void hd_output_sect(natb vetto[])
{
	hd_wait_for_br();
	outputbw(reinterpret_cast<natw*>(vetto), 256, iBR);
}

natb buff[8*512];
int main()
{
	natl lba = 1;
	natb quanti = 2;					// massimo 8
	for (int i = 0; i < quanti*512; i++)
		buff[i] = 'f';

	hd_start_cmd(lba, quanti, WRITE_SECT);
	for (int i = 0; i < quanti; i++)
		hd_output_sect(&buff[i * 512]);

	str_write("OK\n");
	pause();
	// ...
	return 0;
}
//****************************************************************************************************
