//****************************************************************************************************
// file leggiset.cpp
#include <libce.h>

namespace hd {

const ioaddr iBR = 0x01F0;
const ioaddr iCNL = 0x01F4;
const ioaddr iCNH = 0x01F5;
const ioaddr iSNR = 0x01F3;
const ioaddr iHND = 0x01F6;
const ioaddr iSCR = 0x01F2;
const ioaddr iERR = 0x01F1;
const ioaddr iCMD = 0x01F7;
const ioaddr iSTS = 0x01F7;
const ioaddr iDCR = 0x03F6;

};

using namespace hd;

void hd_wait_for_br()
{
	natb s;
	do
		s = inputb(iSTS);
	while (s & 0x88 != 0x08);
}

void hd_input_sect(natb vetto[])
{
	hd_wait_for_br();
	inputbw(iBR, reinterpret_cast<natw*>(vetto), 256);
}

void leggisett(natl lba, natb quanti, natb vetti[])
{
	hd_start_cmd(lba, quanti, 0x20);

	for (int i = 0; i < quanti; i++) {
		hd_input_sect(&vetti[i * 512]);
	}
}

natb buff[8*512];
int main()
{
	natl lba = 1;
	natb quanti = 2;						// massimo 8
	leggisett(lba, quanti, buff);
	for (int i = 0; i < quanti*512; i++)
		char_write(buff[i]);
	char_write('\n');
	pause();
	// ...
	return 0;
}
//****************************************************************************************************

