#include <libce.h>
#include <apic.h>
#include <vid.h>
#include <kbd.h>

using namespace vid;
using namespace kbd;

void enable_intr_kbd()
{
	outputb(0x60, iCMR);
	outputb(0x61, iTBR);
}

void disable_intr_kbd()
{
	outputb(0x60, iCMR);
	outputb(0x60, iTBR);
}

volatile bool fine = false;

extern "C" void a_tastiera();
extern "C" void c_tastiera()
{
	natb c = inputb(iRBR);
	if (c == 0x01)	// make code di ESC
		fine = true;
	for (int i = 0; i < 8; i++) {
		char_write('0' + !!(c & 0x80));
		c <<= 1;
	}
	char_write('\n');
	apic_send_EOI();
}

const natb KBD_VECT = 0x40;
int main()
{
	char spinner[] = { '|', '/', '-', '\\' };

	clear_screen(0x0f);
	apic_set_VECT(1, KBD_VECT);
	gate_init(KBD_VECT, a_tastiera);
	apic_set_MIRQ(1, false);
	enable_intr_kbd();

	natq spinpos = 0;
	while (!fine) {
		video[12*80+40] = attr | spinner[spinpos % 4];
		spinpos++;
	}
	return 0;
}
