#include <libce.h>
#include <timer.h>
#include <apic.h>

using namespace tim;

volatile natq counter = 0;
extern "C" void c_timer()
{
	counter++;
	apic_send_EOI();
}


void attiva_timer(natw N)
{
	outputb(0b00110111, iCWR); // timer 0, modo 3
	outputb(N, iCTR0_LOW);
	outputb(N >> 8, iCTR0_HIG);
}

extern "C" void a_timer();
const natb TIM_VECT = 0x50;
int main()
{
	apic_set_VECT(2, TIM_VECT);
	gate_init(TIM_VECT, a_timer);
	attiva_timer(50000); // periodo di circa 50ms
	apic_set_TRGM(2, false); // false: fronte, true: livello
	apic_set_MIRQ(2, false);

	for (volatile int i = 0; i < 100000000; i++)
		;
	printf("counter = %d\n", counter);
	pause();
}
