#include <libce.h>
#include <apic.h>
#include <vid.h>
#include <kbd.h>

using namespace vid;
using namespace kbd;

volatile bool fine = false;
char spinner[] = { '|', '/', '-', '\\' };

extern "C" void c_tastiera()
{
	natb c = inputb(iRBR);
	if (c == 0x01)	// make code di ESC
		fine = true;
	for (int i = 0; i < 8; i++) {
		char_write('0' + !!(c & 0x80));
		c <<= 1;
		for (volatile int j = 0; j < 10000000; j++)
			;
	}
	char_write('\n');
	apic_send_EOI();
}

extern "C" void c_timer()
{
	static natq timer_spinpos = 0;
	video[12*80+60] = attr | spinner[timer_spinpos % 4];
	timer_spinpos++;
	apic_send_EOI();
}

extern "C" void a_tastiera();
extern "C" void a_timer();

const natb KBD_VECT = 0x40;
const natb TIM_VECT = 0x50;
int main()
{
	clear_screen(0x0f);

	apic_set_VECT(1, KBD_VECT);
	gate_init(KBD_VECT, a_tastiera);
	apic_set_MIRQ(1, false);
	enable_intr_kbd();

	apic_set_VECT(2, TIM_VECT);
	gate_init(TIM_VECT, a_timer);
	attiva_timer(50000); // periodo di circa 50ms
	apic_set_TRGM(2, false); // false: fronte, true: livello
	apic_set_MIRQ(2, false);

	natq spinpos = 0;
	while (!fine) {
		video[12*80+40] = attr | spinner[spinpos % 4];
		spinpos++;
	}
	return 0;
}
